# Copyright (C) 2020 
#
# The source code in this file is released under the GPLv3.
# Go to https://www.gnu.org/licenses/gpl.txt for the full license details.
#
class Map:
    def __init__(self, width, height, map_data):
        self.width = width
        self.height = height
        self.map_data = map_data

IDX_START = 0
IDX_LAST_STORAGE_LEVEL = 8

levels = (

# -1
Map(11, 6, map_data="\
wwwwwwww   \
w.kwewsw   \
wc.w.w.w   \
w.cwow.wwww\
w......d.bw\
wwwwwwwwwww\
"),

# -2
Map(12, 12, map_data="\
www www www \
wsw wbw wew \
w.w w.www.w \
w.w w.d.wow \
w.w www.w.w \
w.w   w.w.w \
w.wwwww.w.ww\
w......c...w\
wwwwcwwwwwww\
  wk.w      \
  wwkw      \
   www      \
"),

# -3
Map(13, 10, map_data="\
www       www\
wbw       wew\
wdw  www  wow\
wkw  wsw  w.w\
wdwwww.wwwwdw\
w...........w\
w.cc...cc.c.w\
w.kcccccc.c.w\
w.ck....c.c.w\
wwwwwwwwwwwww\
"),

# -4
Map(12, 11, map_data= "\
wwwwwwwwww  \
w.kccccckw  \
wcc.cc.ccw  \
w....c...w  \
w...wwww.w  \
w...o.ew.w  \
wwwwwwww.www\
   wsw w.dbw\
   w.www.www\
   w.....w  \
   wwwwwww  \
"),

# -5
Map(12, 9, map_data="\
www  www www\
wew  wsw wbw\
wowwww.w wdw\
w......w wdw\
w......wwwdw\
w.c........w\
wc.cccccc.cw\
wc.kkc..kccw\
wwwwwwwwwwww\
"),

#-6
Map(13, 11, map_data = "\
wwwwwwww  www\
w.ckkwsw  wew\
w.wwww.wwww.w\
wdwk.c.c..o.w\
wkw.c.c.c.www\
wdw.ccc.c.w  \
w...ck....w  \
wwwwwwwwwdw  \
        wdw  \
        wbw  \
        www  \
"),

# -7 keyskeyskeys 
Map(12, 10, map_data = "\
www wwwwwwww\
wswwwkkkbwew\
w.wddkkkkwow\
w.wdwwwwwwdw\
w.wdwkkkkwdw\
w...wwwwdwdw\
w..cwkkwdwdw\
wcc.wwdwkwdw\
w........ddw\
wwwwwwwwwwww\
"),

# -8 cratescratescrates
Map(12, 10, map_data = "\
wwwwwwwwwwww\
wew.c.s..wkw\
wdw.c..c.wow\
w..c..cc.c.w\
w.c.c..c...w\
wccc...ccc.w\
w...cc..c..w\
w.w.c.c..c.w\
wbw.c..c.ccw\
wwwwwwwwwwww\
"),

# -9 RESCUE NANJI!
Map(12, 9, map_data = "\
  w      w  \
 wsw    wEw \
 w.w    wnw \
ww.wwwwwwoww\
w..c..c.c..w\
w.ccc.cc.c.w\
w.c.c.b...cw\
 wcc....c.w \
  wwwwwwww  \
"),



# Sneaking upstairs...

# Office 1 - meet Johnny and Evilguy
Map(9, 10, map_data = "\
   WWW   \
   WEW   \
  WWoWW  \
WWW.t.WWW\
Wkd.C.dbW\
WWW.k.WWW\
  WW.WW  \
   W.W   \
   WSW   \
   WWW   \
"),

# doorsdoorsdoors
Map(12, 11, map_data = "\
WWW      WWW\
WbWWWWWWWWEW\
WdW.tk..CWoW\
WdW.W.CC...W\
WdddWC...C.W\
WWWWW...CkCW\
WkCWk..WWWWW\
W..CC.WW...W\
W.C......W.W\
WWkWWWWWWWSW\
 WWW     WWW\
"),

# use plant to block path .. or run in circle
Map(13, 11, map_data = "\
       WWW   \
       WEW   \
       WoWWWW\
WWW    Wt...W\
WbW    WkCW.W\
WdWWWWWWk.W.W\
W.d.d..k.CW.W\
W.WWWWWWWWW.W\
W...........W\
WSWWWWWWWWWWW\
WWW          \
"),

# a little tricky
Map(10, 9, map_data = "\
WWWWWWWWWW\
WEW....WbW\
WoW....ddW\
W...t..WWW\
WWWCC....W\
  W.kCCW.W\
  WC.k.W.W\
  WWWWWWSW\
       WWW\
"),

# AI hard at work..
Map(12, 10, map_data = "\
WWWWWWWWWWWW\
WbWkdddkkkkW\
WdWkWWWWWWWW\
WdWdWCCWWWkW\
WdW....WEWkW\
WdW....WoWkW\
W.WS.....WdW\
W.WWW....WdW\
W........tkW\
WWWWWWWWWWWW\
"),


Map(11, 10, map_data = "\
WWWWWWW WWW\
WkkkWEW WbW\
WdWWWoWWWdW\
W.CWC.....W\
W.WWWWWWWdW\
W.W....kWdW\
W.W.W.WtWdW\
W.W.W.WkWdW\
W...WSWk..W\
WWWWWWWWWWW\
"),

# final map - looks dramatic but is actually hard to fail
Map(7, 11, map_data = "\
  WWW  \
  WEW  \
  WoW  \
WWW.WWW\
WCC.CCW\
WCbtCCW\
WCC.CCW\
WWW.WWW\
  W.W  \
  WSW  \
  WWW  \
")

)

#   void
# . ground
# w wall
# c crate
# o buttondoor
# b button for buttondoor
# d door
# k key
# s start
# e exit
# n Nanji (or Nanji-lookalike)

# W office wall
# C office plant
# t trigger AI spawn - spawn points are the 2 floor tiles ABOVE the start location 
# S office start 
# E office exit


# empty sample map
"""
Map(12, 10, map_data = "\
............\
............\
............\
............\
............\
............\
............\
............\
............\
............\
")
"""

